<link rel="import" href="../polymer/polymer-element.html" />
<link rel="import" href="../../bower_components/paper-input/paper-input.html" />

<dom-module id="mi-propiedades">
    <template>
        <style>
            :host {
                display: block;
            }
        </style>
        <h2>Hello [[prop1]]!</h2>
        <span>Otra propiedad: "[[currentValue]]"</span>
        <hr />
        <button on-click="cambiarValor">Cambiar valor</button>

        <h3>Data binding</h3>
        <a href="http://[[url]]">[[url]]</a>
        <paper-input label="Escribe algo" value="{{url}}"></paper-input>

        <h3>Observers</h3>
        <p>[[valoracion]]</p>

        <h3>Computed properties</h3>
        <fieldset>
            <label>Primer número: [[param1]]</label><br />
            <label>Segundo número: [[param2]]</label>
            <p>La suma es: <strong>[[totalCalculo]]</strong></p>
        </fieldset>
    </template>

    <script>
        /**
         * `mi-propiedades`
         * asdfghjmk
         *
         * @customElement
         * @polymer
         * @demo demo/index.html
         */
        class MiPropiedades extends Polymer.Element {
            static get is() {
                return "mi-propiedades";
            }
            static get properties() {
                return {
                    prop1: {
                        type: String,
                        value: "mi-propiedades",
                    },
                    param1: Number,
                    param2: Number,
                    fechaTransaccion: {
                        type: Date,
                        value: new Date(),
                        readOnly: false,
                        reflectToAttribute: true,
                    },
                    currentValue: {
                        type: String,
                    },
                    url: {
                        type: String,
                        value: "www.google.com",
                    },
                    valoracion: {
                        value: true,
                        type: String,
                        notify: true,
                        observer: "_valoracionObserver",
                    },
                    totalCalculo: {
                        type: Number,
                        value: 0,
                        readOnly: true,
                        notify: true,
                        computed: "sumaTotalesTransaccion(param1, param2)",
                    },
                };
            }
            cambiarValor() {
                this.fechaTransaccion = Date.now();
                this.valoracion = Date.now().toString();
                this.param1 = Math.trunc(Math.random() * 10);
            }
            sumaTotalesTransaccion(pm1, pm2) {
                return pm1 + pm2;
            }
            _valoracionObserver(newValue, oldValue) {
                if (!newValue) {
                    console.log(`El nuevo valor es ${newValue}`);
                } else {
                    console.log(`oldValue: ${oldValue}`);
                }
            }
        }

        window.customElements.define(MiPropiedades.is, MiPropiedades);
    </script>
</dom-module>
